program DDS_Netzwerktester;
uses crt,graph,async,dos,lfont,ldriv;

var graphdriver,graphmode,errorcode :integer;
    b        : byte;
    f,w,t,e  : longint;
    ch       : char;
    err      : boolean;
    port     : integer;
    cfgfile  :text;
    zeile,dat:string;
    code     :integer;
    i        :integer;
    bneu     : array[1..200] of integer;
    balt     : array[1..200] of integer;
    farbe    : word;
    k1       : integer;
    k2       : real;
    zeit     : integer;
    Driver   : integer;
     Mode    : integer;
     nummer  : integer;

function IntToStr(i: Longint): string;
var
  s: string[11];
begin
  Str(i, s);
  IntToStr := s;
end;

function dezimal(d: longint): string;
var s : string;
begin
  str(d,s);
  if length(s)>3 then insert('.',s,length(s)-2);
  if length(s)>7 then insert('.',s,length(s)-6);
  dezimal:=s
end;

procedure datenio(f:longint; var d:byte; var fehler:boolean);

var f1,f2,f3,f4    :byte;
    i              :integer;
    startzeit      :word;
    z,x,k          :real;
    li             :longint;
    b0,b1,b2,b3    :byte;

begin
  clearbuffer;
  fehler:=false;
x:=f;
k:=42.94967296*100000000/t;
z:=k*x;
li:=round(z);
b0:=trunc(li/16777216);
f1:=b0;
li:=li-b0*16777216;
b1:=trunc(li/65536);
f2:=b1;
li:=li-b1*65536;
b2:=trunc(li/256);
f3:=b2;
li:=li-b2*256;
f4:=trunc(li);
{ 028F5C28 1 MHz}
send(f4);send(f3);send(f2);send(f1);
if zeit>1 then delay(zeit) else delay(2);
send($aa);
startzeit:=timercount;

{Demo}

 repeat
     if timercount-startzeit>10 then fehler:=true
 until dataready or fehler=true;
 d:=rcv;

 {d:=80}
end;

procedure z_in(var zahl:longint);

var s :string;
    err:integer;

begin
clearviewport;
 s:='';
 repeat
  ch:=readkey;
  outtext(ch);
  if ch<>char(13) then s:=s+ch;
 until ch=char(13);
 clearviewport;
 val(s,zahl,err);
 if err<>0 then zahl:=1;
 setviewport(0,0,639,479,true);
end;

procedure clearmaxwert;
begin
 setviewport(300,420,550,442,true);
 clearviewport;
 setviewport(0,0,639,479,true);
end;

procedure f_out;
var s,t :string;
     zw :real;

 begin
  clearmaxwert;
  setviewport(160,420,500,432,true);
  clearviewport;
  setviewport(0,0,639,479,true);
  s:=dezimal(f)+' Hz';
  outtextxy(50,420,'Start(f)requenz : ');
  outtextxy(160,420,s);
  datenio(f,b,err);
  zw:=(((b-k1)*k2)-320)/4;
  s:=inttostr(round(zw))+' dB';
  outtextxy(300,420,'Wert : ');
  outtextxy(350,420,s);

 end;

procedure w_out;
var s,t :string;

 begin
  s:=dezimal(w)+' Hz';
  outtextxy(50,440,'Schritt(w)eite  : ');
  outtextxy(160,440,s);
 end;

procedure maxwert;
var fmax : longint;
    fx   : longint;
    amax : integer;
    s    : string;
    i,j  : integer;

begin
 setviewport(300,420,500,432,true);
 clearviewport;
 setviewport(0,0,639,479,true);
 fx:=f;amax:=0;
 for i:=1 to 200 do
  begin
   if balt[i]>amax then begin fmax:=fx;amax:=balt[i];j:=i end;
   fx:=fx+w;
  end;
 s:='Max: '+dezimal(fmax)+' Hz, '+inttostr(round((amax-320)/4))+' dB';
 outtextxy(300,420,s);
 fx:=fmax;
 i:=j;
 repeat
 fx:=fx-w;
 i:=i-1;
 until (balt[i]<=amax-24) or (i<=1);
 repeat
 fmax:=fmax+w;
 j:=j+1;
 until (balt[j]<=amax-24) or (j>=200);
 if (i>1) or (j<200) then
 begin
  s:='B6 : ('+dezimal(fx)+', '+dezimal(fmax)+', '+dezimal(fmax-fx)+') Hz';
  outtextxy(300,430,s);
 end
end;



procedure feingabe;

begin
 clearmaxwert;
 setviewport(160,420,500,432,true);
 z_in(f);
 f_out
end;


procedure weingabe;
begin
 setviewport(160,440,400,450,true);
 z_in(w);
 w_out
end;

procedure messbereich(posx,posy:integer;f,w:longint);
var x  :integer;
    s  :string;

begin
  setviewport(posx-8,posy+10,600,posy+20,true);
  clearviewport;
  setviewport(0,0,639,479,true);
  setcolor(lightgray);

  x:=0;
  for i:=1 to 6 do
      begin
      outtextxy(posx+x-8,posy+10,dezimal(f));
      f:=f+40*w;
      x:=x+80
      end;
  setcolor(white);
  for i:= 1 to 200 do
   begin
     bneu[i]:=0;
     if balt[i] mod 40=0 then farbe:=lightgray else farbe:=blue;
     putpixel(posx+i*2-1,posy-balt[i],farbe);
     putpixel(posx+i*2-1,posy-bneu[i],white);
     balt[i]:=bneu[i];
   end;

end;

procedure linlin(posx,posy:integer;f,sw:longint);
var x,i:integer;
    s  :string;

begin
  settextstyle(2,0,0);
  setcolor(lightgray);
  x:=0;
  for i:=1 to 9 do
      begin
      str((i-1)*10-80,s);
      line(posx,posy-x,posx+400,posy-x);outtextxy(posx-25,posy-x-8,s);
      x:=x+40
      end;
  x:=0;
  for i:=1 to 6 do
      begin
      line(posx+x,posy,posx+x,posy-320);
      outtextxy(posx+x-8,posy+10,dezimal(f));
      f:=f+40*sw;
      x:=x+80
      end;
  x:=0;
  for i:=1 to 11 do
      begin
      line(posx+x,posy,posx+x,posy-4);
      x:=x+40
      end;
  setcolor(white);
end;

procedure messdaten(xpos,ypos:integer);
var fneu: longint;

begin
repeat
fneu:=f;
  for i:= 1 to 200 do
   begin
     datenIO(fneu,b,err);
     if err then exit;
     bneu[i]:=round((b-k1)*k2);
     if bneu[i]<0 then bneu[i]:=0;
     if balt[i] mod 40=0 then farbe:=lightgray else farbe:=blue;
     putpixel(xpos+i*2-1,ypos-balt[i],farbe);
     putpixel(xpos+i*2-1,ypos-bneu[i],white);
     fneu:= fneu+w;
     balt[i]:=bneu[i];
   end;
until keypressed or err;
end;

procedure grafikausgabe;
begin
 if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
  begin
   WriteLn('Error registering driver: ',GraphErrorMsg(GraphResult));
   Halt(1);
  end;
 if RegisterBGIfont(@smallFont) < 0 then
  begin
   WriteLn('Error registering font: ',GraphErrorMsg(GraphResult));
   Halt(1);
  end;

{ Init graphics }
  Driver := vga;
  Mode := vgaHi;
  InitGraph(Driver, Mode, '');

  setbkcolor(blue);
  clearviewport;
  outtextxy(50,20,'Netzwerktester V2 DK3WX                 '+dat);
  settextstyle(2,0,0);
{  outtextxy(250,460,'(z.Z. keine Fehlerbehandlung implementiert)');}
  outtextxy(460,50,'(S)tart');
  outtextxy(460,90,'Sto(p)');
  outtextxy(460,130,'Pl(u)s');
  outtextxy(460,170,'(M)inus');
  outtextxy(460,210,'(B)ereich');
  outtextxy(460,250,'K(-)80 dB');
  outtextxy(460,290,'K(+)0 dB');
  outtextxy(460,330,'Spe(i)chern');
  outtextxy(460,370,'(Q)uitt');
  linlin(50,380,f,w);
  f_out;
  w_out;
end;

procedure beep;
 begin
  Sound(600);        { Beep }
  Delay(200);        { For 200 ms }
  NoSound;           { Relief! }
end;

procedure fmax;
begin
f:=f+w;
if f>e then begin f:=f-w;beep end;
f_out;
end;

procedure fmin;
begin
f:=f-w;
if f<=0 then begin f:=f+w;beep end;
f_out;
end;


procedure readk1;
 var sum      :integer;
begin
 clearmaxwert;
 sum:=0;
 for i:= 1 to 10 do
 begin
  datenio(10000000,b,err);
  sum:=sum+b
 end;
 k1:=round(sum/10);
 datenio(f,b,err);
end;

procedure readk2;
 var sum      :integer;
begin
 clearmaxwert;
 sum:=0;
 for i:= 1 to 10 do
 begin
  datenio(10000000,b,err);
  sum:=sum+b
 end;
 if (sum/10-k1) > 0 then k2:=320/(sum/10-k1);
 datenio(f,b,err);
end;

procedure speichern;
var dat : text;
    fx  : longint;
begin
 assign(dat,'nwt'+inttostr(nummer)+'.dat');
 rewrite(dat);
 fx:=f;
 for i:=1 to 200 do
 begin
  writeln(dat,inttostr(fx)+';'+inttostr(round((balt[i]-320)/4)));
  fx:=fx+w;
 end;
 close(dat);
 nummer:=nummer+1;
end;

begin
 if ParamCount < 1 then dat:='nwt.cfg' else dat:=paramstr(1)+'.cfg';
assign(cfgfile,dat);
  {$I-}
Reset(cfgfile);
  {$I+}
if IOResult = 0 then
                 begin
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, f, Code);
                 if code <> 0 then f:=10000000;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, e, Code);
                 if code <> 0 then e:=35000000;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, w, Code);
                 if code <> 0 then w:=1000;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, t, Code);
                 if code <> 0 then t:=100000000;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, port, Code);
                 if code <> 0 then port:=2;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, k1, Code);
                 if code <> 0 then k1:=50;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, k2, Code);
                 if code <> 0 then k2:=2.5;
                 readln(cfgfile,zeile);
                 delete(zeile,1,pos('=',zeile));
                 Val(zeile, zeit, Code);
                 if code <> 0 then zeit:=1;
                 close(cfgfile)
                 end
                else
                 begin
                 rewrite(cfgfile);
                 writeln(cfgfile,'Startfrequenz=10000000');
                 writeln(cfgfile,'Endfrequenz  =35000000');
                 writeln(cfgfile,'Schrittweite =10000');
                 writeln(cfgfile,'Taktfrequenz =100000000');
                 writeln(cfgfile,'Comport      =2');
                 writeln(cfgfile,'Korrfaktor1  =50');
                 writeln(cfgfile,'Korrfaktor2  =2.5');
                 writeln(cfgfile,'Delay        =1');
                 close(cfgfile);
                 f:=10000000;
                 w:=10000;
                 e:=35000000;
                 t:=100000000;
                 port:=2;
                 k1:=50;k2:=2.5;
                 zeit:=1;
                 end;

  nummer:=1;
  set_com_port(port,9600,8,1,0);
  grafikausgabe;
  repeat
  ch:=readkey;
  case ch of
  'F','f':begin feingabe; end;
  'W','w':weingabe;
  'U','u':fmax ;
  'M','m':fmin;
  '-'    :readk1;
  '+'    :readk2;
  #0     :begin ch:=readkey;
          case ch of
          char(72):fmax;
          char(80):fmin;
          end;
          end;
  'S','s':begin
            if f+200*w>e then beep
            else
            begin
            clearmaxwert;
            messbereich(50,380,f,w); messdaten(50,380);ch:='p'
            end
          end ;
  'P','p':maxwert;
  'B','b':begin clearmaxwert;messbereich(50,380,f,w);end;
  'Q','q':ch:=char(27);
  'I','i':speichern;
  end
  until (ch=char(27)) or (err=true);
  closegraph;
  clrscr;
  if err then begin writeln;writeln;writeln;writeln;
   write('   Abbruch durch Datenbertragungsfehler')
   end;
  reset_comport;
 str(k2:4:2,zeile);
rewrite(cfgfile);
writeln(cfgfile,'Startfrequenz='+inttostr(f));
writeln(cfgfile,'Endfrequenz  ='+inttostr(e));
writeln(cfgfile,'Schrittweite ='+inttostr(w));
writeln(cfgfile,'Taktfrequenz ='+inttostr(t));
writeln(cfgfile,'Comport      ='+inttostr(port));
writeln(cfgfile,'Korrfaktor1  ='+inttostr(k1));
writeln(cfgfile,'Korrfaktor2  ='+zeile);
writeln(cfgfile,'Delay        ='+inttostr(zeit));
close(cfgfile)

end.